'+--------------------------------------------------------------------------+
'|                               IconMenu                                   |
'|                                                                          |
'|                      Skin Engine for VISTA and XP                        |
'|           with full crystal and blur effect in composited mode           |
'|                                                                          |
'|  Example that shows you how to use the GDImage.dll to display icon menu  |
'|  with interactive animation "a la WPF" without DirectX nor OpenGL.       |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 03-21-2008 (MM-DD-YYYY)            |
'|                        Last revised : 03-21-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "IconMenu.exe"

'//DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

#RESOURCE "iconmenu.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO

#INCLUDE "ZSKIN.INC"

%VK_PRIOR                                       = &H21
%VK_NEXT                                        = &H22
%VK_END                                         = &H23
%VK_HOME                                        = &H24
%VK_LEFT                                        = &H25
%VK_NUMPAD4                                     = &H64
%VK_UP                                          = &H26
%VK_NUMPAD8                                     = &H68
%VK_RIGHT                                       = &H27
%VK_NUMPAD6                                     = &H66
%VK_DOWN                                        = &H28
%VK_NUMPAD2                                     = &H62

TYPE POINTS
  x AS INTEGER
  y AS INTEGER
END TYPE

#INCLUDE "GDIMAGE.INC"
'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
TYPE SpriteArrayStruct
    ImageName AS ASCIIZ * 128
    hBitmap   AS LONG
    ID        AS LONG
    xPos      AS LONG
    yPos      AS LONG
    'nWidth    AS LONG
    'nHeight   AS LONG
    'rAngle    AS SINGLE
    scale     AS SINGLE
    selected  AS LONG
END TYPE

%XMIN_SIZE = 801
%YMIN_SIZE = 480

%AERO_TIMER             = 1
%ICON_MENU_TIMER        = 2

%ID_CTRL                = -1
%ID_THUMB               = -2
%ID_BTN_RESET           = -3
%ID_BTN_MARQUEE         = -4
%ID_BTN_WALLPAPER       = -5
%ID_BTN_REFLECTION      = -6

%ID_FRAMEBUTTON         = -7
%ID_GLASS_OPACITY_LABEL = -8
%ID_TRACK_OPACITY       = -9
%ID_AEROCRYSTAL         = -10
%ID_AEROBLUR            = -11
%ID_AERODISABLE         = -12
%ID_BTN_HELP            = -13

%ID_OBJECT_THUMB   = 7
%ID_OBJECT_TEXT    = 8
%ID_OBJECT_LABEL   = 9
%ID_OBJECT_SPRITE  = 10 ' Do not use 11,12,13,14,15 (they are reserved for the icon sprites)

%Speed_default = 4
%Focus_default = 15000
%Y_default     = 50

GLOBAL gbAnimate AS LONG, gSpriteArray() AS SpriteArrayStruct, gCtrl, gThumb AS LONG
GLOBAL gnMarqueeWidth, gnMarqueeHeight AS LONG
GLOBAL grScaleDefault, grScaleStep AS SINGLE, gnInflateID AS LONG
GLOBAL gnSelectID AS LONG

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZCAROUSEL"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zInstance
       wc.hIcon         = %NULL ' LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL ' Don't paint the class window background
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
'
     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "IconMenu"
       hMain = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                             zClass, _               ' Class Name
                             (MyTitle$), _           ' Window Title
                             dwStyle, _              ' Defined Window Style
                             x, y, _                 ' Window Position
                             rc.nRight - rc.nLeft, _ ' Calculate Window Width
                             rc.nBottom - rc.nTop, _ ' Calculate Window Height
                             %NULL, _                ' No Parent Window
                             %NULL, _                ' No Menu
                             wc.hInstance, _         ' Instance
                             BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(hMain, "BluePlayer.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls(hMain)

'         // Load the icon menu sprites to be used for the animation
          CALL LoadSprites()
          gbAnimate = %TRUE '// Turn on, the GDImage mouse hover animation. 

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(5) ' 5 = UseStep for composited window on XP

'         // Fire the scrolling marquee help      
          CALL zSetCheckButtonStatus(GetDlgItem(hMain, %ID_BTN_MARQUEE), %TRUE)
          CALL ZD_ShowObject(%ID_OBJECT_TEXT, %ZD_SHOW)

          CALL SetTimer(hMain, %ICON_MENU_TIMER, 0, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(hMain, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND
          CALL KillTimer(hMain, %ICON_MENU_TIMER)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Add child controls to main window
SUB AddChildControls(BYVAL hMain AS LONG)

    LOCAL hCtrl, hBitmap, x, y, bmW, bmH, BackgroundColor AS LONG
    LOCAL Alpha, Red, Green, Blue AS BYTE
    
'   Use the same font for both Aero and Standard mode    
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

    'BackgroundColor = RGB(27,29,41)
    CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
    BackgroundColor = ZD_ColorARGB(0, RGB(Blue, Green, Red))
    
'   Create the GDImage main graphic control
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = %WS_EX_TRANSPARENT
    gCtrl = CreateWindowEx(StyleEx&, _
                           "ZIMAGECTRL", _            ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           17, _                      ' initial x position
                           42, _                      ' initial y position
                           588, _                     ' Calculate Window Width
                           420, _                     ' Calculate Window Height
                           hMain, _                   ' parent window handle
                           %ID_CTRL, _                ' ControlID
                           zInstance(), _             ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   In case of image background stretch it to match the size of the graphic control
'   or center it when smaller than the view port.
    CALL ZI_SetProperty(gCtrl, %ZI_FitToWindow, %ZI_QualityDefault)
'   Resize the control to macth the whole size of the parent window
    CALL zSetAnchorMode(gCtrl, %ANCHOR_HEIGHT_WIDTH)
'   Use blue color for background
    CALL ZI_SetProperty(gCtrl, %ZI_GradientTop, RGB(Red, Green, Blue))
    CALL ZI_SetProperty(gCtrl, %ZI_GradientBottom, RGB(Red, Green, Blue))


'   Create the GDImage thumb graphic control
    gThumb = CreateWindowEx(StyleEx&, _
                           "ZIMAGECTRL", _            ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           634, _                     ' initial x position
                           140, _                     ' initial y position
                           128, _                     ' Calculate Window Width
                           128, _                     ' Calculate Window Height
                           hMain, _                   ' parent window handle
                           %ID_THUMB, _               ' ControlID
                           zInstance(), _             ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   Use blue color for background
    CALL ZI_SetProperty(gThumb, %ZI_GradientTop, BackgroundColor)
    CALL ZI_SetProperty(gThumb, %ZI_GradientBottom, BackgroundColor)
    hBitmap = ZI_CreateBitmapFromFile(zsExePath() + "user.png", bmW, bmH)
    IF hBitmap THEN
       x = (128 - bmW) \ 2
       y = (128 - bmH) \ 2
       CALL ZD_DrawBitmapToCtrl(gThumb, x, y, hBitmap, ZD_ColorARGB(0, 0), %ID_OBJECT_THUMB, %ZS_VISIBLE)
       CALL ZD_UsePngOpacity(%ID_OBJECT_THUMB, %TRUE)
       CALL ZD_SetObjectLocked(%ID_OBJECT_THUMB, %TRUE)
    END IF
    CALL zSetAnchorMode(gThumb, %ANCHOR_RIGHT)

'   // Tell GDImage we want to use a callback to process
'   // some Windows messages as events:
  ' Enable the %WM_LBUTTONDOWN event
    CALL ZI_EventMessage(CODEPTR(MyCallBack), %WM_LBUTTONDOWN, %TRUE)
  ' Enable the %WM_LBUTTONDBLCLK event
    CALL ZI_EventMessage(CODEPTR(MyCallBack), %WM_LBUTTONDBLCLK, %TRUE)
  ' Enable the %WM_RBUTTONDOWN event
    CALL ZI_EventMessage(CODEPTR(MyCallBack), %WM_RBUTTONDOWN, %TRUE)
  ' Enable the %WM_KEYDOWN event
    CALL ZI_EventMessage(CODEPTR(MyCallBack), %WM_KEYDOWN, %TRUE)
  ' Enable the %WM_MOUSEMOVE event
    CALL ZI_EventMessage(CODEPTR(MyCallBack), %WM_MOUSEMOVE, %TRUE)
'   ___________________

    hCtrl = zFrameButton(hMain, (SK_FOLDER() + "Frame3D.png"), "", 619, 47, 158, 410, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
'   ___________________

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Scrolling help", 627, 52, 110, 22, %ID_BTN_MARQUEE, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Hide or show scrolling help using marquee effect")
    
    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Wallpaper", 627, 72, 110, 22, %ID_BTN_WALLPAPER, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Hide or show image background")

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Reflection", 627, 92, 110, 22, %ID_BTN_REFLECTION, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Hide or show sprite reflection")

    hCtrl = zPushButton(hMain, (SK_FOLDER() + "BTN_Push.png"), "Reset location", 626, 307, 144, 28, %ID_BTN_RESET, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Restaure to initial location")
'   ___________________

IF Vista() THEN
    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "AERO Crystal mode", 627, 349, 130, 22, %ID_AEROCRYSTAL, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Switch Skin display to CRYSTAL mode")

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "AERO Blur mode", 627, 370, 130, 22, %ID_AEROBLUR, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Switch Skin display to BLUR mode")

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "STANDARD mode", 627, 391, 130, 22, %ID_AERODISABLE, SK_BTNTEXTCOLOR(), 0)
    CALL zSetCheckButtonStatus(hCtrl, %TRUE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Switch back to standard display mode")

    hCtrl = zStaticLabel(hMain, "Client zone opacity", 628, 420, 140, 15, %ID_GLASS_OPACITY_LABEL, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)

    CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
    hCtrl = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 628, 435, 140, 14, %ID_TRACK_OPACITY, 1, 255, Alpha, SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "To change client opacity (AERO must be On)")
END IF

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_User.png"), 10, 8, %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(hMain, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(hMain, %ID_LED), %HWND_TOP)

    IF zGetCheckButtonStatus(GetDlgItem(hMain, %ID_BTN_MARQUEE)) THEN
       CALL ZD_ShowObject(%ID_OBJECT_TEXT, %ZD_SHOW)
    ELSE
       CALL ZD_ShowObject(%ID_OBJECT_TEXT, %ZD_HIDE)
    END IF             

END SUB

SUB DrawMarquee()
    LOCAL x, y AS LONG
    LOCAL rc AS RECt
    CALL GetClientRect(gCtrl, rc)
    CALL ZD_GetObjectXY(%ID_OBJECT_TEXT, x, y)
    x = x - 2	
    IF x < - gnMarqueeWidth THEN x = rc.nRight 
    CALL ZD_SetObjectXY(%ID_OBJECT_TEXT, x, y, %ZD_DRAW_DEFERRED)
END SUB

SUB DrawSprites(BYVAL hWnd AS LONG)

    REGISTER K AS LONG
    LOCAL Angle AS SINGLE, x, y, yOffset, nSelected AS LONG
    LOCAL Alpha, Red, Green, Blue AS BYTE
   
    IF gbAnimate THEN

       FOR K = UBOUND(gSpriteArray) TO LBOUND(gSpriteArray) STEP -1
           IF gnInflateID = gSpriteArray(K).ID THEN
              IF gSpriteArray(K).scale < 1 THEN gSpriteArray(K).scale = gSpriteArray(K).scale + grScaleStep
              CALL ZD_GetObjectARGB(%ID_OBJECT_LABEL, Alpha, Red, Green, Blue)
              IF Alpha < 255 THEN 
                 Alpha = alpha + 3: CALL ZD_SetObjectAlpha(%ID_OBJECT_LABEL, (Alpha), %FALSE)
                 IF Alpha = 255 THEN
                    CALL ZD_SetObjectARGBcolor(%ID_OBJECT_LABEL, ZD_ColorARGB(Alpha, RGB(220,0,0)))'RGB(233,233,75)))
                    CALL ZD_SetObjectUse3Dshadow(%ID_OBJECT_LABEL, 1) '// Enable shadow
                 END IF
              END IF
           ELSE
              IF gSpriteArray(K).scale > grScaleDefault THEN gSpriteArray(K).scale = gSpriteArray(K).scale - grScaleStep
           END IF
           CALL ZD_SetObjectScale(gSpriteArray(K).ID, gSpriteArray(K).scale)
           Angle = ZD_GetObjectAngle(%ID_OBJECT_SPRITE + K)
           IF Angle > 0 THEN
              Angle = Angle - 8
              CALL ZD_SetObjectAngle(%ID_OBJECT_SPRITE + K, Angle, %FALSE)
              
'             // Restore original state if reflection is being used
              IF Angle < 8 THEN
                 IF zGetCheckButtonStatus(zGetMainItem(%ID_BTN_REFLECTION)) THEN
                    nSelected = gSpriteArray(K).Selected
                    IF nSelected THEN
                       gSpriteArray(nSelected).hBitmap = ZI_CreateMirrorBitmapFromFile(gSpriteArray(nSelected).ImageName, bmW&, bmH&)
                       yOffset = -8
                       CALL ZD_GetObjectXY(%ID_OBJECT_SPRITE + nSelected, x, y)
                       CALL ZD_DrawBitmapToCtrl(gCtrl, x, y + yOffset, _
                                                gSpriteArray(nSelected).hBitmap, &HFFFFFFFF, gSpriteArray(nSelected).ID, %ZS_VISIBLE)
                       gSpriteArray(nSelected).Selected = 0
                    END IF
                 END IF            
              END IF
              
           END IF
       NEXT

       CALL ZD_GetObjectARGB(%ID_OBJECT_THUMB, Alpha, Red, Green, Blue)
       IF gnSelectID THEN
          IF Alpha < 255 THEN
             Alpha = Alpha + 1: ZD_SetObjectAlpha(%ID_OBJECT_THUMB, (Alpha), %TRUE)
          END IF
       ELSE
          IF Alpha > 0 THEN
             Alpha = Alpha - 1: ZD_SetObjectAlpha(%ID_OBJECT_THUMB, (Alpha), %TRUE)
          END IF 
       END IF 
    
       IF zGetCheckButtonStatus(zGetMainItem(%ID_BTN_MARQUEE)) THEN
          CALL DrawMarquee()
       END IF

     ' Update the control display
       CALL ZI_UpdateWindow(gCtrl, 0)

    END IF
END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
    LOCAL hDC, INT_REFLECTION, K, x, y, yOffset, nLevel AS LONG
    LOCAL Alpha, Red, Green, Blue AS BYTE

    STATIC IsMoving AS LONG

    SELECT CASE LONG Msg
    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_BTN_REFLECTION
              INT_REFLECTION = zGetCheckButtonStatus(zGetMainItem(%ID_BTN_REFLECTION))
              FOR K = LBOUND(gSpriteArray) TO UBOUND(gSpriteArray)
                  IF INT_REFLECTION THEN
                     gSpriteArray(K).hBitmap = ZI_CreateMirrorBitmapFromFile(gSpriteArray(K).ImageName, bmW&, bmH&)
                     yOffset = -8
                  ELSE
                     gSpriteArray(K).hBitmap = ZI_CreateBitmapFromFile(gSpriteArray(K).ImageName, bmW&, bmH&)
                     yOffset = 8
                  END IF
                  CALL ZD_GetObjectXY(%ID_OBJECT_SPRITE + K, x, y)
                  CALL ZD_DrawBitmapToCtrl(gCtrl, x, y + yOffset, _
                                           gSpriteArray(K).hBitmap, &HFFFFFFFF, gSpriteArray(K).ID, %ZS_VISIBLE)
              NEXT

         CASE %ID_BTN_WALLPAPER
              IF zGetCheckButtonStatus(zGetMainItem(%ID_BTN_WALLPAPER)) THEN
                  CALL ZI_SetFromFile(gCtrl, zsExePath() + "Back.jpg")
              ELSE
                  CALL ZI_SetFromFile(gCtrl, zsExePath() + "No_Picture.png")
              END IF

         CASE %ID_BTN_MARQUEE              
              IF zGetCheckButtonStatus(zGetMainItem(%ID_BTN_MARQUEE)) THEN
                  CALL ZD_ShowObject(%ID_OBJECT_TEXT, %ZD_SHOW)
              ELSE
                  CALL ZD_ShowObject(%ID_OBJECT_TEXT, %ZD_HIDE)
              END IF             
              
         CASE %ID_BTN_RESET

              IF zGetCheckButtonStatus(zGetMainItem(%ID_BTN_REFLECTION)) THEN
                 yOffset = 8
              ELSE
                 yOffset = 0
              END IF
              FOR K = LBOUND(gSpriteArray) TO UBOUND(gSpriteArray)
                  CALL ZD_SetObjectXY(%ID_OBJECT_SPRITE + K, gSpriteArray(K).xPos, gSpriteArray(K).yPos - yOffset, %FALSE)
                  CALL ZD_SetObjectAngle(%ID_OBJECT_SPRITE + K, 0, %FALSE)
              NEXT
              CALL ZI_UpdateWindow(gCtrl, %FALSE)
   
         CASE %ID_AEROCRYSTAL
              CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) THEN
                 nLevel = zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY))
                 CALL zAEROCOLOR(zColorARGB(nLevel, RGB(Red, Green, Blue)), %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(0, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

                 CALL ZI_SetProperty(gThumb, %ZI_GradientTop, SK_AEROCOLOR())
                 CALL ZI_SetProperty(gThumb, %ZI_GradientBottom, SK_AEROCOLOR())

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL ZI_SetProperty(gThumb, %ZI_GradientTop, RGB(Red, Green, Blue))
                 CALL ZI_SetProperty(gThumb, %ZI_GradientBottom, RGB(Red, Green, Blue))

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AEROBLUR
              CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR)) THEN
                 nLevel = zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY))
                 CALL zAEROCOLOR(zColorARGB(nLevel, RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(6, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
                 CALL zUSEVISTABLUR(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

                 CALL ZI_SetProperty(gThumb, %ZI_GradientTop, SK_AEROCOLOR())
                 CALL ZI_SetProperty(gThumb, %ZI_GradientBottom, SK_AEROCOLOR())

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL ZI_SetProperty(gThumb, %ZI_GradientTop, RGB(Red, Green, Blue))
                 CALL ZI_SetProperty(gThumb, %ZI_GradientBottom, RGB(Red, Green, Blue))

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AERODISABLE
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE)) THEN
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%FALSE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                 CALL zUpdateWindow(hWnd, 0)
              ELSE
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)
              END IF
         CASE %ID_TRACK_OPACITY
              IF SK_AEROEMULATE() THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(lParam, RGB(Red, Green, Blue)), %WRITE)

                 CALL ZI_SetProperty(gThumb, %ZI_GradientTop, SK_AEROCOLOR())
                 CALL ZI_SetProperty(gThumb, %ZI_GradientBottom, SK_AEROCOLOR())

                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                 CALL zUpdateWindow(hWnd, 0)
              END IF
         CASE %ID_BTN_HELP
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com/winlift/gdimage.htm", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION
              
         END SELECT

    CASE %WM_SIZE
         IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
         CALL zDrawBackground()
         CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
         'CALL zUpdateWindow(hWnd, 0)
         IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG, p AS POINTAPI
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window 
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

'   //START AERO section ---------------------------------------------------------
    CASE %WM_TIMER
         IF wParam = %ICON_MENU_TIMER THEN
            CALL DrawSprites(hWnd)
         ELSE
            IF zDwmIsCompositionEnabled() = 0 THEN
               IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                  IF zIsLButtonDown() = 0 THEN IsMoving = 0
                  IF IsMoving = 0 OR (zIsLButtonDown() AND IsMoving) THEN
                     CALL GetWindowRect(hWnd, rc)
                     CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                     CALL zUpdateWindow(hWnd, 0)
                  END IF
               END IF
            END IF
         END IF
         
    CASE %WM_NCLBUTTONDOWN
         IsMoving = -1

    CASE %WM_MOVING
         IF zDwmIsCompositionEnabled() = 0 THEN
            IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
               DIM rw AS RECT PTR
               rw = lparam
               CALL zMoveBackground(@rw.nLeft,@rw.nTop, 0)
               CALL zUpdateWindow(hWnd, 0)
               FUNCTION = 1: EXIT FUNCTION
            END IF
         END IF
'   //END AERO section ---------------------------------------------------------

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB LoadSprites()

    DIM gSpriteArray(1 TO 5) AS SpriteArrayStruct
    LOCAL K, xLeft, yOffset, UboundSpriteData, INT_REFLECTION AS LONG
    LOCAL sLabel AS STRING
    LOCAL rc AS RECT

'   Setup defalt parameters
    grScaleDefault = 0.75
    grScaleStep = 0.01

    gSpriteArray(1).ImageName = zsExePath() + "Office Publisher.png"
    gSpriteArray(2).ImageName = zsExePath() + "Office Word.png"
    gSpriteArray(3).ImageName = zsExePath() + "Office Outlook.png"
    gSpriteArray(4).ImageName = zsExePath() + "Office PowerPoint.png"
    gSpriteArray(5).ImageName = zsExePath() + "Office Excel.png"


    CALL GetClientRect(gCtrl, rc)
    UboundSpriteData = UBOUND(gSpriteArray)
    xLeft = (rc.nRight - ((32 * (UboundSpriteData - 1)) + (64 * UboundSpriteData))) / 2
    xLeft = xLeft - ((128 - 64) / 2)

    INT_REFLECTION = zGetCheckButtonStatus(zGetMainItem(%ID_BTN_REFLECTION))
    FOR K = LBOUND(gSpriteArray) TO UboundSpriteData
        IF INT_REFLECTION THEN
           gSpriteArray(K).hBitmap = ZI_CreateMirrorBitmapFromFile(gSpriteArray(K).ImageName, bmW&, bmH&)
           yOffset = 8
        ELSE
           gSpriteArray(K).hBitmap = ZI_CreateBitmapFromFile(gSpriteArray(K).ImageName, bmW&, bmH&)
           yOffset = 0
        END IF

        gSpriteArray(K).ID   = %ID_OBJECT_SPRITE + K
        gSpriteArray(K).xPos = xLeft
        gSpriteArray(K).yPos = 64
        xLeft = xLeft + (64 + 32)

        CALL ZD_DrawBitmapToCtrl(gCtrl, gSpriteArray(K).xPos, gSpriteArray(K).yPos, _
                                 gSpriteArray(K).hBitmap, &HFFFFFFFF, gSpriteArray(K).ID, %ZS_VISIBLE)

        gSpriteArray(K).scale = grScaleDefault
        CALL ZD_SetObjectScale(gSpriteArray(K).ID, gSpriteArray(K).scale)

        CALL ZD_UsePngOpacity(%ID_OBJECT_SPRITE + K, %TRUE)
        
        CALL zSplitN(gSpriteArray(K).ImageName, "", sLabel)
        CALL ZD_SetObjectImageLabel(%ID_OBJECT_SPRITE + K, Extract$(sLabel, "."))

    NEXT

    ARGB& = ZD_ColorARGB(128, RGB(255,255,255))
    MarqueeMsg$ = "Left mouse button down to drag the icon, double click to perform selection ..."
    FontToUse$ = "Times New Roman"
    CALL ZD_DrawTextToCtrl(gCtrl, _
                           (MarqueeMsg$), _   ' The text to be displayed
                           rc.nRight, _       ' X coordinate
                           2, _               ' Y coordinate
                           ARGB&, _           ' ARGB color to use
                           (FontToUse$), _    ' The True Type Font to use (must be a valid one)
                           20, _              ' The font size in pixel
                           %ID_OBJECT_TEXT, _ ' The unique object ID
                           %ZS_VISIBLE, _     ' Overlay visible at startup
                           0, _               ' Optional shadow effect (offset in pixel)
                           0)                 ' Optional string format
    CALL ZD_GetObjectBound(%ID_OBJECT_TEXT, gnMarqueeWidth, gnMarqueeHeight)

    ARGB& = ZD_ColorARGB(255, RGB(255,255,255))
    CALL ZD_DrawTextToCtrl(gCtrl, _
                           "", _               ' The text to be displayed
                           rc.nRight, _        ' X coordinate
                           10, _               ' Y coordinate
                           ARGB&, _            ' ARGB color to use
                           (FontToUse$), _     ' The True Type Font to use (must be a valid one)
                           40, _               ' The font size in pixel
                           %ID_OBJECT_LABEL, _ ' The unique object ID
                           %ZS_VISIBLE, _      ' Overlay visible at startup
                           0, _                ' Optional shadow effect (offset in pixel)
                           0)                  ' Optional string format

END SUB

'// This is the place where we process the GDImage callback events
FUNCTION MyCallBack(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL nObjectID AS LONG, rc AS RECT, nRet AS LONG
    LOCAL x, y, yOffset, x1, y1 AS LONG

    nRet = %FALSE ' Do not stop the event processing in GDImage

    IF hWnd = zGetMainItem(%ID_CTRL) THEN ' In case we use the same callback for several GDImage control
                                          ' make sure that we handle the good one.
       nObjectID = ZI_MouseOverObjectID()
       
       SELECT CASE LONG Msg

       CASE %WM_LBUTTONDOWN

       CASE %WM_LBUTTONDBLCLK
            IF nObjectID > %ID_OBJECT_SPRITE THEN
               CALL ZD_SetObjectAngle(nObjectID, 360, %FALSE)

               gnSelectID = nObjectID - 10
'              // If reflection is active then disable it, while performing self rotation of the object.
               IF zGetCheckButtonStatus(zGetMainItem(%ID_BTN_REFLECTION)) THEN
                  gSpriteArray(gnSelectID).hBitmap = ZI_CreateBitmapFromFile(gSpriteArray(gnSelectID).ImageName, bmW&, bmH&)
                  yOffset = 8
                  CALL ZD_GetObjectXY(%ID_OBJECT_SPRITE + gnSelectID, x, y)
                  CALL ZD_DrawBitmapToCtrl(gCtrl, x, y + yOffset, _
                                           gSpriteArray(gnSelectID).hBitmap, &HFFFFFFFF, gSpriteArray(gnSelectID).ID, %ZS_VISIBLE)
                  gSpriteArray(gnSelectID).Selected = gnSelectID
               END IF            
                        
               '////////////////////////////////////////////////
               '// Put you code there to perfom the selection //
               '////////////////////////////////////////////////
                                
            END IF

       CASE %WM_RBUTTONDOWN

       CASE %WM_MOUSEMOVE
            IF nObjectID THEN ' > ID_OBJECT_SPRITE THEN
                IF gnInflateID <> nObjectID THEN
                    gnInflateID = nObjectID
                    IF ZD_GetObjectZorder(nObjectID) <> %ZD_ORDER_TOP THEN
                        ZD_SetObjectZorder(nObjectID, %ZD_ORDER_TOP)

                        ' Show current label
                        LOCAL nBoundWidth, nBoundHeight AS LONG
                        CALL ZD_SetObjectARGBcolor(%ID_OBJECT_LABEL, ZD_ColorARGB(0, RGB(255,0,0)))
                        CALL ZD_SetObjectUse3Dshadow(%ID_OBJECT_LABEL, 0) ' Disable shadow if any
                        CALL ZD_SetObjectText(%ID_OBJECT_LABEL, ZD_GetObjectImageLabel(nObjectID)) 
                        CALL ZD_GetObjectBound(%ID_OBJECT_LABEL, nBoundWidth, nBoundHeight)
                        CALL GetClientRect(zGetMainItem(%ID_CTRL), rc)
                        CALL ZD_SetObjectXY(%ID_OBJECT_LABEL, (rc.nRight - nBoundWidth) / 2, rc.nBottom - (nBoundHeight * 2), %ZD_DRAW_DEFERRED)
                        CALL ZD_SetObjectVisibility(%ID_OBJECT_LABEL, %TRUE)
                        CALL ZD_SetObjectZorder(%ID_OBJECT_LABEL, %ZD_ORDER_BOTTOM)
                        gnSelectID = 0
                                                
                    END IF
                END IF
            ELSE ' Clear the label         
                CALL ZD_SetObjectAlpha(%ID_OBJECT_LABEL, 0, %FALSE)
                CALL ZD_SetObjectVisibility(%ID_OBJECT_LABEL, %FALSE)
                gnSelectID = 0
            END IF

       CASE %WM_KEYDOWN
            IF nObjectID = %ID_CTRL THEN nObjectID = 0 ' Do not move the image background
            IF nObjectID THEN
               CALL ZD_GetObjectXY(nObjectID, x, y)
               x1 = x ' Make a copy to keep the orignal x location unchanged
               y1 = y ' Make a copy to keep the orignal y location unchanged

             ' Check accelerator keys to compute the step range
               IF ZI_IsCtrlKeyPressed THEN
                  UseStep& = 4
                  IF ZI_IsShiftKeyPressed THEN UseStep& = 16
               ELSEIF ZI_IsShiftKeyPressed THEN
                  UseStep& = 2
               ELSE
                  UseStep& = 1
               END IF

               IF ZD_GetObjectScroll(nObjectID) THEN ' If object scroll with the bitmap background
                ' Get the size of the bitmap background
                  CALL ZI_GetBitmapSize(ZI_GetBMP(zGetMainItem(%ID_CTRL)), useWidth&, useHeight&)
               ELSE
                ' Get the control client size
                  CALL GetClientRect(zGetMainItem(%ID_CTRL), rc)
                  useWidth& = rc.nRight: useHeight& = rc.nBottom
               END IF
             ' Get the sprite object size
               CALL ZD_GetObjectBound(nObjectID, BoundWidth&, BoundHeight&)

               x2Div2& = (BoundWidth& \ 2): y2Div2& = BoundHeight& \ 2

               SELECT CASE wParam
               CASE %VK_HOME
                    x1 = 0
               CASE %VK_END
                    x1 = MAX&(useWidth& - BoundWidth&, 0)
               CASE %VK_PRIOR
                    y1 = 0
               CASE %VK_NEXT
                    y1 = MAX&(useHeight& - BoundHeight&, 0)
               CASE %VK_LEFT, %VK_NUMPAD4
                    IF x1 > -x2Div2& THEN x1 = MAX&(x1 - UseStep&, -x2Div2&)
               CASE %VK_UP, %VK_NUMPAD8
                    IF y1 > -y2Div2& THEN y1 = MAX&(y1 - UseStep&, -y2Div2&)
               CASE %VK_RIGHT, %VK_NUMPAD6
                    IF x1 < useWidth& - x2Div2& THEN
                       x1 = MIN&(x1 + UseStep&, useWidth& - x2Div2&)
                    END IF
               CASE %VK_DOWN, %VK_NUMPAD2
                    IF y1 < useHeight& - y2Div2& THEN
                    y1 = MIN&(y1 + UseStep&, useHeight& - y2Div2&)
                    END IF
               END SELECT

               IF x <> x1 OR y <> y1 THEN
                  x = x1: y = y1
                  CALL ZD_SetObjectXY(nObjectID, x1, y1, %TRUE)
               END IF
            END IF
       END SELECT
    END IF

    FUNCTION = nRet
END FUNCTION
